﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;

namespace ultraGanttViewPrint
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.ultraPrintPreviewDialog1.Document = this.ultraPrintDocument1;
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Code used to populate ultraTree
            this.ultraTree1.DataSource = GetEmployDepartmentDataSet();

            //Code used to populate ultraGanttView
            //// Create a new Project other than the Unassigned Project
            //Project quarterlyProject = this.ultraCalendarInfo1.Projects.Add("QuartlerlyProject", DateTime.Today);
            //quarterlyProject.Key = "projkey1";

            //// Create a Summary or Parent Task
            //Task requirementsTask = this.ultraCalendarInfo1.Tasks.Add(DateTime.Today, TimeSpan.FromDays(5), "Requirements", "projkey1");

            //// Create a child task
            //Task budgetTask = requirementsTask.Tasks.Add(DateTime.Today, TimeSpan.FromDays(2), "Budget Analysis");
            //// Set Deadline
            //budgetTask.Deadline = DateTime.Today.AddDays(3);
            ////Assign a Resource for this task
            //Owner budgetOwner = this.ultraCalendarInfo1.Owners.Add("BudgetOwner", "Bill Isacky");
            //budgetTask.Resources.Add(budgetOwner);

            //// Create another child task
            //Task teamTask = requirementsTask.Tasks.Add(DateTime.Today.AddDays(3), TimeSpan.FromDays(2), "Team Allocation");
            //// Set a Constraint for this Task
            //teamTask.ConstraintDateTime = DateTime.Today.AddDays(4);
            //teamTask.Constraint = TaskConstraint.FinishNoLaterThan;



            //// Create a Summary or Parent Task
            //Task implemetationTask = this.ultraCalendarInfo1.Tasks.Add(DateTime.Now.AddDays(7), TimeSpan.FromDays(3), "Implementation", "projkey1");

            //// Create a child task
            //Task frontendTask = implemetationTask.Tasks.Add(DateTime.Now.AddDays(7), TimeSpan.FromDays(3), "GUI Design");
            //// Set this task as a Milestone
            //frontendTask.Milestone = true;
            //// Set Percent Complete for this Task
            //frontendTask.PercentComplete = 40;
            //frontendTask.Dependencies.Add(budgetTask, TaskDependencyType.StartToStart);
            //frontendTask.Dependencies.Add(teamTask, TaskDependencyType.FinishToStart);

            //this.ultraGanttView1.CalendarInfo = this.ultraCalendarInfo1;
            //// Assign the new Project to GanttView so that this Project is shown in GanttView and not the unassigned Project.
            //this.ultraGanttView1.Project = this.ultraGanttView1.CalendarInfo.Projects[1];

        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            //Code used to save ultraGanttView to bmp
            //Bitmap bmp = new Bitmap(this.ultraGanttView1.Width, this.ultraGanttView1.Height);
            //this.ultraGanttView1.DrawToBitmap(bmp, new Rectangle(0, 0, this.ultraGanttView1.Width, this.ultraGanttView1.Height));
            //bmp.Save("output1.bmp");

            //Code used to save ultraTree to bmp
            Bitmap bmp1 = new Bitmap(this.ultraTree1.Width, this.ultraTree1.Height);
            this.ultraTree1.DrawToBitmap(bmp1, new Rectangle(0,0,this.ultraTree1.Width, this.ultraTree1.Height));
            bmp1.Save("outputTree.bmp");
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            ultraPrintDocument1.Print();
        }

        private void ultraPrintDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            //Code used to print ultraGanttView
            //Bitmap bmp = new Bitmap(this.ultraGanttView1.ClientRectangle.Width, this.ultraGanttView1.ClientRectangle.Height);
            //this.ultraGanttView1.DrawToBitmap(bmp, ultraGanttView1.ClientRectangle);
            //e.Graphics.DrawImage(bmp, 0, 0);   

            //Code used to print ultraTree
            Bitmap bmp1 = new Bitmap(this.ultraTree1.ClientRectangle.Width, this.ultraTree1.ClientRectangle.Height);
            this.ultraTree1.DrawToBitmap(bmp1, ultraTree1.ClientRectangle);
            e.Graphics.DrawImage(bmp1, 0, 0);   
        }

        #region SampleData

        enum SampleTables
        {
            Departments,
            Employees,
            EmployeeOptions
        }

        private DataTable GetSampleTable(SampleTables table)
        {
            DataTable retVal;
            switch (table)
            {
                case SampleTables.Departments:
                    retVal = this.GetDepartments();
                    break;
                case SampleTables.Employees:
                    retVal = this.GetEmployees();
                    break;
                case SampleTables.EmployeeOptions:
                    retVal = this.GetEmployeeOptions();
                    break;
                default:
                    retVal = this.GetEmployees();
                    break;
            }
            return retVal;
        }

        private DataSet GetEmployDepartmentDataSet()
        {
            DataSet ds = new DataSet("EmployeeRecords");

            // Get the tables to use in the DataSet
            DataTable Employees = this.GetEmployees();
            DataTable Departments = this.GetDepartments();
            DataTable Options = this.GetEmployeeOptions();

            // Add the tables to the DataSet
            ds.Tables.Add(Departments);
            ds.Tables.Add(Employees);
            ds.Tables.Add(Options);

            // Create the relationship between the tables.
            ds.Relations.Add("DepartmentEmployee", Departments.Columns["DepartmentID"], Employees.Columns["Department"]);
            ds.Relations.Add("EmployeeOption", Employees.Columns["EmployeeID"], Options.Columns["Employee"]);
            return ds;
        }

        private DataTable GetDepartments()
        {
            DataTable dt = new DataTable("Departments");
            dt.Columns.Add("DepartmentID", typeof(int));
            dt.Columns.Add("DepartmentName", typeof(string));

            for (int i = 0; i < 8; i++)
            {
                dt.Rows.Add(new object[] { i, string.Format("Department {0}", i) });
            }

            dt.PrimaryKey = new DataColumn[] { dt.Columns["DepartmentID"] };

            return dt;
        }

        private DataTable GetEmployees()
        {
            return this.GetEmployees(24);
        }

        private DataTable GetEmployees(int count)
        {
            DataTable dtData = new DataTable("Employees");

            dtData.Columns.Add("EmployeeID", typeof(int));
            dtData.Columns.Add("Name", typeof(string));
            dtData.Columns.Add("OnSite", typeof(bool));
            dtData.Columns.Add("DateOfHire", typeof(DateTime));
            dtData.Columns.Add("Department", typeof(int));
            dtData.Columns.Add("Site", typeof(string));


            for (int i = 0; i < count; i++)
            {
                dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), (i % 2 == 0), DateTime.Today.Date.AddDays(-1 * i), i % 8, "http://www.google.com" });
            }

            dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

            return dtData;
        }

        private DataTable GetEmployeeOptions()
        {
            DataTable dtData = new DataTable("EmployeeOptions");

            dtData.Columns.Add("OptionID", typeof(int));
            dtData.Columns.Add("Employee", typeof(int));
            dtData.Columns.Add("Option", typeof(string));
            dtData.Columns.Add("Description", typeof(string));


            for (int i = 0; i < 96; i++)
            {
                dtData.Rows.Add(new object[] { i, i % 24, string.Format("Option {0}", i), String.Format("Option Description {0}", i) });
            }

            dtData.PrimaryKey = new DataColumn[] { dtData.Columns["OptionID"] };

            return dtData;
        }

        #endregion SampleData


    }
}
